
{% set modal_id = modal_id if modal_id else "insert_image_modal" %}
{% set form_id = form_id if form_id else "insert_image_form" %}
{% set modal_title = modal_title if modal_title else _("Insert image") %}

<!-- {{modal_id}} -->

<div class="modal fade insert-image-modal" id="{{modal_id}}" tabindex="-1" role="dialog" aria-labelledby="{{modal_id}}-label" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="{{modal_id}}-label">{{ modal_title }}</h5>
        <button type="button" data-bs-dismiss="modal" aria-label="Close">
          <svg xmlns="http://www.w3.org/2000/svg" width="32" height="32" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="1" stroke-linecap="round" stroke-linejoin="round" class="feather feather-x" aria-hidden="true"><line x1="18" y1="6" x2="6" y2="18"></line><line x1="6" y1="6" x2="18" y2="18"></line></svg>
        </button>
      </div>
      <div class="modal-body">
        <form id="{{form_id}}" enctype="multipart/form-data" data-parsley-validate>
          <div class="form-group mt-1">
            {{ upload_media_form.alt_text.label( for="", class_="form-label") }}
            {{ upload_media_form.alt_text(
                    class_="form-control",
                    placeholder=_('A photo of a horse galloping on the beach.'))
            }}
            <div class="form-text">{{ _("Describe the image. This helps people with visual challenges.") }}</div>
          </div>
          <div class="form-group mt-3">
            <label for="image_url" class="form-label">{{ _("Image URL") }}</label>
            <input type="url" class="form-control" id="image_url" placeholder="https://" />
            <div class="form-text">{{ _("Use an image already available on the Internet.") }}</div>
          </div>
          {% if current_user.can_upload() %}
          <div class="form-group mt-3">
              <label for="media_file" class="form-label">{{ _("Or upload a new image") }}</label>
              {{ upload_media_form.media_file(
                          id="media_file",
                          class_="form-control",
                          multiple="false",
                          data_parsley_maxfilesize=config['MAX_MEDIA_SIZE'],
                          data_parsley_mimetypes="image/png, image/jpeg",
                        )
              }}
              <div class="form-text">
                {{ _("The file should be no larger than %(size)s", size = human_readable_bytes(config["MAX_MEDIA_SIZE"])) }}
              </div>
          </div>
          {% endif %}
          <div class="mt-4">
            <button id="imageModalSaveButton" type="submit" class="btn btn-primary">
              {% if is_background_image %}{{ _("Set background") }}{% else %}{{ _("Insert") }}{% endif %}
            </button>
          </div>
          <!-- <div id="media_file_error" class="ds-error" style="display:none"></div> -->
        </form>
      </div>
      <div class="modal-footer d-block" {% if not current_user.media.count() %}style="display:none !important"{% endif %}>
        <p class="pb-0">{{ _("Optionally, reuse one of your previous images") }}</p>
        <div class="media-list mt-2"></div>
      </div>
    </div>
  </div>
</div>

<script>
if (typeof triggerAddImageEvent !== "function") { // Only add this code once to the DOM
  function triggerAddImageEvent(form_id) {
    if (form_id == "insert_background_image_form") {
      $(document).trigger("add_background_image");
    }
    else if (form_id == "insert_header_image_form") {
      $(document).trigger("add_header_image");
    }
    else {
      $(document).trigger("insert_image", [form_id]); // insert image into markdown editor
    }
  }
  window.Parsley.addValidator('maxfilesize', {
    validateString: function(_value, maxSize, parsleyInstance) {
      if (!window.FormData) {
        return true;
      }
      var files = parsleyInstance.$element[0].files;
      return files.length != 1  || files[0].size <= maxSize;
   },
    requirementType: 'integer',
    messages: {
      {{ g.language }}: "{{ _('The file is too large. Max. %(size)s', size = human_readable_bytes(config['MAX_MEDIA_SIZE'])) }}"
    }
  })
  window.Parsley.addValidator('mimetypes', {
    validateString: function(_value, requirement, parsleyInstance) {
      if (!window.FormData) {
        return true;
      }
      var file = parsleyInstance.$element[0].files;
      if (file.length == 0) {
        return true;
      }
      var allowedMimeTypes = requirement.replace(/\s/g, "").split(',');
      return allowedMimeTypes.indexOf(file[0].type) !== -1;
    },
    requirementType: 'string',
    messages: {
      {{ g.language }}: "{{ _('File type not allowed') }}"
    }
  });
}
var loaded_thumbnails = false
jQuery(function($) {
  $('.insert-image-modal').on('show.bs.modal', function() {
    if (! loaded_thumbnails) {
      loaded_thumbnails = true
      $.ajax({
        url : "{{url_for('media_bp.user_media_thumbnails')}}",
        type: "GET",
        dataType: "json",
        beforeSend: function(xhr, settings) {
          if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type)) {
            xhr.setRequestHeader("X-CSRFToken", csrftoken)
          }
        },
        success: function(data, textStatus, jqXHR)
        {
          data.media.forEach(media => {
            var thumbnail = thumbnailElement(media.id, media.thumbnail_url, media.alt_text)
            $(".media-list").prepend(thumbnail)
          });
        }
      });
    }
  });
  $('#{{modal_id}}').on('hidden.bs.modal', function() {
    $("#{{form_id}}").find('#alt_text').val("");
    $("#{{form_id}}").find('#image_url').val("");
    $("#{{form_id}}").find('#media_file').val("");
  });
  $("#{{form_id}}").on('change', '#new_image_file', function(){
    $('#new_image_file_error').hide()
  });
  $("#{{modal_id}}").find(".media-list").on("click", "img", function() {
    var media_id = $(this).attr("media_id")
    $.ajax({
      url : "/media/get-values/"+media_id,
      type: "GET",
      dataType: "json",
      beforeSend: function(xhr, settings) {
        if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type)) {
          xhr.setRequestHeader("X-CSRFToken", csrftoken)
        }
      },
      success: function(data, textStatus, jqXHR)
      {
        if (data !== false) {
          $("#{{form_id}}").find('#alt_text').val(data.media.alt_text);
          $("#{{form_id}}").find('#image_url').val(data.media.image_url);
          $("#{{form_id}}").find('#media_file').val('');
          triggerAddImageEvent("{{form_id}}");
        }
      }
    });
  });
  var parsley_options = {
    errorsContainer: function (field) {
      return $(field.element).closest(".form-group ")
    }
  }
  $('#{{form_id}}').parsley(parsley_options)
  //.on('field:validated', function() {
  //  var ok = $('.parsley-error').length === 0;
  //  $('.bs-callout-info').toggleClass('hidden', !ok);
  //  $('.bs-callout-warning').toggleClass('hidden', ok);
  //})
  .on('form:submit', function() {
    event.preventDefault();
    if (! ($("#{{form_id}}").find('#image_url').val() ||
          $("#{{form_id}}").find('#media_file').val())) {
      return
    }
    {% if not current_user.can_upload() %}
      triggerAddImageEvent("{{form_id}}");
    {% else %}
      var formFields = document.getElementById('{{form_id}}').elements;
      var file = formFields['media_file'].files[0];
      if (file === undefined) {
        triggerAddImageEvent("{{form_id}}");
      } else {
        var form_data = new FormData();
        form_data.append('media_file', file);
        form_data.append('alt_text', $("#{{form_id}}").find('#alt_text').val());
        $.ajax({
            url : "{{url_for('media_bp.save_media')}}",
            type: "POST",
            data : form_data,
            processData: false,
            contentType: false,
            beforeSend: function(xhr, settings) {
              if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type)) {
                  xhr.setRequestHeader("X-CSRFToken", csrftoken)
              }
            },
            success: function(data, textStatus, jqXHR)
            {
              if (data.errors === undefined) {
                $("#{{form_id}}").find('#image_url').val(data.media.image_url);
                $("#{{form_id}}").find('#alt_text').val(data.media.alt_text)
                triggerAddImageEvent("{{form_id}}")
                let thumbnail = thumbnailElement(data.media.id, data.media.thumbnail_url, data.media.alt_text)
                $(".media-list").prepend(thumbnail)
                $(".modal-footer").show()
              }
            }
        });
      }
    {% endif %}
  });
});
function thumbnailElement(media_id, thumbnail_url, alt_text) {
  let template = `<img src="%thumbnail_url%" class="ds-media-thumbnail" alt="%alt_text%" title="%alt_text%" media_id="%image_id%" />`
  return template.replace(/%thumbnail_url%/g, thumbnail_url)
                 .replace(/%alt_text%/g, alt_text)
                 .replace(/%image_id%/g, media_id)
}
</script>
